import 'package:equatable/equatable.dart';
import 'package:flutter/foundation.dart';

@immutable
class Entity extends Equatable {
  final List<EntityFailure> errors;

  @override
  bool get stringify => true;

  Entity({this.errors = const []});
  bool hasErrors() => errors.isNotEmpty;
  bool hasError(EntityFailure error) => errors.indexOf(error) > 0;

  merge({errors}) {
    return Entity(errors: errors);
  }

  @override
  List<Object> get props => [errors];
}

class EntityFailure extends Equatable {
  const EntityFailure();

  @override
  List<Object> get props => [];
}

class GeneralEntityFailure extends EntityFailure {
  const GeneralEntityFailure();
}

class NoConnectivityEntityFailure extends EntityFailure {
  const NoConnectivityEntityFailure();
}
